#!/bin/sh

#
# You can set JAVA_HOME to point ot JDK 1.3 
# or shell will try to deterine java location using which
#

#JAVA_HOME=/l/jdk1.3

# 
# No need to modify anything after this line.
# --------------------------------------------------------------------


if [ -z "$JAVA_HOME" ] ; then
  JAVA=`/usr/bin/which java`
  if [ -z "$JAVA" ] ; then
    echo "Cannot find JAVA. Please set your PATH."
    exit 1
  fi
  JAVA_BIN=`dirname $JAVA`
  JAVA_HOME=$JAVA_BIN/..
else
  JAVA=$JAVA_HOME/bin/java
fi

#echo "JAVA= $JAVA"

if [ ! "`$JAVA -version 2>&1 | grep "\ 1\.3"`" ]; then 
    echo Required 1.3 verion of JDK: can not use $JAVA
    echo Current version is:
    $JAVA -version
    exit 1
fi 

#POLICY=-Djava.security.policy=${TOP}/src/tests/java.policy
#-Debug=true -Dlog.names=
#JAVA_OPTS=-Debug=true
#JAVA_OPTS="$JAVA_OPTS -Djava.compiler=NONE"
JAVA_OPTS="-Dlog=xcat:ALL -Djava.compiler=NONE"

TOP=.

CP=`echo lib/*.jar | tr ' ' ':'`
CP=$JAVA_HOME/lib/tools.jar:$CP
CP=${TOP}/build/classes:$CP
#CP=${TOP}/build/samples:$CP
#CP=${TOP}/build/xsoap.jar:$CP

if [ -z "$1" ] ; then
   echo Please specify test name.
   exit 1
fi

NAME=$1
shift

if [ "$NAME" = "compose" ] ; then
  CMD="$JAVA $JAVA_OPTS -cp $CP samples.compose.Compose  $*"
elif [ "$NAME" = "composeObject" ] ; then
    CMD="$JAVA $JAVA_OPTS -cp $CP samples.composeObject.ComposeObject  $*"
elif [ "$NAME" = "tokenizer" -o "$NAME" = "sxtcount"  -o "$NAME" = "sxt_count" -o "$NAME" = "sxt" ] ; then
    CMD="$JAVA $JAVA_OPTS -cp $CP samples.pullparser.SXTCount  $*"
else
    CMD="$JAVA $JAVA_OPTS -cp $CP $NAME $*"
fi

echo $CMD
$CMD
