package samples.idl.testObject;

import soaprmi.RemoteException;
import soaprmi.util.Logger;
import soaprmi.util.Level;

public class TestObject {
  
  private int intData;
  private String stringData;
  private static Logger logger = Logger.getLogger();

  public TestObject(){
    intData = 0;
    stringData = "Default";
  }

  public TestObject(int i, String s){
    intData = i;
    stringData = s;
  }

  public int getIntData(){
    return intData;
  }
    
  public String getStringData(){
    return stringData;
  }

  public void setIntData(int intParam){
    intData = intParam;
  }
    
  public void setStringData(String stringParam){
    stringData = stringParam;
  }

  public boolean equals(Object o) {
    if (o == null) {
      logger.severe("received a null object to compare with");
      return false;
    }
    TestObject other;
    try {
      other = (TestObject) o;
    } catch (ClassCastException e) {
      e.printStackTrace();
      logger.severe("received an incompatible object to compare with, class casst exception");
      return false;
    }
    if ( (intData == other.getIntData())
	 &&
	 (stringData.equals(other.getStringData()))
	 ) {
      return true;
    } else {
      logger.finest("the two test objects are not equal"+ toString() + other.toString());
      return false;
    }
  }

  public String toString() {
    return "TestObject" + "["
      +"int="+intData
      +",string="+stringData
      +"]";
  }

}
