package samples.printer;

import samples.idl.string.ProvidesString;
import soaprmi.RemoteException;
import soaprmi.server.UnicastRemoteObject;
import soaprmi.util.Logger;
import soaprmi.util.Level;

/**
 * @version $Revision: 1.3 $  $Author: mgovinda $ $Date: 2001/05/08 20:05:26 $ (GMT) 
 * @author Madhusudhan Govindaraju [mailto:mgovinda@extreme.indiana.edu]
 */
public class PrintMeImpl extends UnicastRemoteObject 
  implements ProvidesString {
  
  private String message = null;
  private static Logger logger = Logger.getLogger();

  /**
   * constructor
   * The constructor has to call the superclass
   * constructor as this is a remote object
   */
  public PrintMeImpl() throws RemoteException {
    super();
  }
  
  /**
   * the string port method will be invoked
   * remotely.
   */
  public void sendString(String s) {
    message = s;
    logger.fine("says the string received is : "+s);
  }
}

