package samples.testObjectPrinter;

import soaprmi.RemoteException;
import soaprmi.server.UnicastRemoteObject;
import samples.idl.testObject.ProvidesTestObject;
import soaprmi.util.Logger;
import soaprmi.util.Level;
import samples.idl.testObject.TestObject;

/**
 * @version $Revision: 1.1.1.1 $  $Author: mgovinda $ $Date: 2001/05/08 20:24:19 $ (GMT) 
 * @author Rachana Ananthakrishnan [mailto:ranantha@extreme.indiana.edu]
 */

public class PrintMeImpl extends UnicastRemoteObject 
implements ProvidesTestObject {

  private static Logger logger = Logger.getLogger();

  /**
   * constructor
   * The constructor has to call the superclass
   * constructor as this is a remote object
   */
  public PrintMeImpl() throws RemoteException {
    super();
  }

  /**
   * the testObject port methods will be invoked
   * remotely.
   */

  public Integer echoInt(Integer intParameter){
    logger.finest("in echoInt");
    Integer intMessage = intParameter;
    logger.fine("says the int Parameter received is : "+ intMessage.intValue());
    return intMessage;
  }

  
  public Long echoLong(Long longParameter){
    logger.finest("in echoLong");
    Long longMessage = longParameter;
    logger.fine("says the long Parameter received is : "+ longMessage.longValue());
    return longMessage;
  }

  public Short echoShort(Short shortParameter){
    logger.finest("in echoShort");
    Short shortMessage = shortParameter;
    logger.fine("says the short Parameter received is : "+ shortMessage.shortValue());
    return shortMessage;
  }
  

  public Double echoDouble(Double doubleParameter){
    logger.finest("in echoDouble");
    Double doubleMessage = doubleParameter;
    logger.fine("says the double Parameter received is : "+ doubleMessage.doubleValue());
    return doubleMessage;
  }

  public Float echoFloat(Float floatParameter){
    logger.finest("in echoFloat");
    Float floatMessage = floatParameter;
    logger.fine("says the float Parameter received is : "+ floatMessage.floatValue());
    return floatMessage;
  }

  public String echoString(String stringParameter){
    logger.finest("in echoString");
    String stringMessage = stringParameter;
    logger.fine("says the string Parameter received is : "+ stringMessage);
    return stringMessage;
  }
  
  public TestObject echoTestObject(TestObject testObject){
    logger.finest("in echoTestObject");
    TestObject testObjectMsg = testObject;
    logger.fine("says the parameter received is : TestObject" + testObject.getIntData() + " ," + testObject.getStringData());
    return testObjectMsg;
  }

  public int[] echoIntArray(int[] intParameter){
    logger.finest("in echoIntArray");
    int[] intMessageArray = intParameter;
    //    logger.fine("says the parameter received is : " + testObject.getIntData() + " ," + testObject.getStringData());
    return intMessageArray;
  }

  /*
  public short[] echoShortArray(short[] shortParameter){
    logger.finest("in echoShortArray");
    short[] shortMessageArray = shortParameter;
    //    logger.fine("says the parameter received is : " + testObject.getShortData() + " ," + testObject.getStringData());
    return shortMessageArray;
  }

  public long[] echoLongArray(long[] longParameter){
    logger.finest("in echoLongArray");
    long[] longMessageArray = longParameter;
    //    logger.fine("says the parameter received is : " + testObject.getLongData() + " ," + testObject.getStringData());
    return longMessageArray;
  }
  */

  public double[] echoDoubleArray(double[] doubleParameter){
    logger.finest("in echoDoubleArray");
    double[] doubleMessageArray = doubleParameter;
    //    logger.fine("says the parameter received is : " + testObject.getDoubleData() + " ," + testObject.getStringData());
    return doubleMessageArray;
  }

  public float[] echoFloatArray(float[] floatParameter){
    logger.finest("in echoFloatArray");
    float[] floatMessageArray = floatParameter;
    //    logger.fine("says the parameter received is : " + testObject.getFloatData() + " ," + testObject.getStringData());
    return floatMessageArray;
  }

  public String[] echoStringArray(String[] StringParameter){
    logger.finest("in echoStringArray");
    String[] StringMessageArray = StringParameter;
    //    logger.fine("says the parameter received is : " + testObject.getStringData() + " ," + testObject.getStringData());
    return StringMessageArray;
  }

  public TestObject[] echoTestObjectArray(TestObject[] TestObjectParameter){
    logger.finest("in echoTestObjectArray");
    TestObject[] TestObjectMessageArray = TestObjectParameter;
    //    logger.fine("says the parameter received is : " + testObject.getTestObjectData() + " ," + testObject.getStringData());
    return TestObjectMessageArray;
  }
}





