/**
 * The CCA object model: the interface that all CCA 
 * components must implement. 
 * Every component that the component developer
 * defines needs to extened from this class.
 * This class is part of the CCA specs. 
 */

/**
 * @version $Revision: 1.3 $ $Author: mgovinda $ $Date: 2001/05/08 20:05:58 $ (GMT) 
 * @author Madhusudhan Govindaraju [mailto:mgovinda@extreme.indiana.edu]
 */

package xcat.framework.ccacore;

public interface Component {
  /**
   * @param svc the services handle object.
   * Obtain Services handle, through which the component 
   * and framework communicate. This is the one method 
   * that every CCA Component must implement. 
   */
  public void setServices(Services svc);
}
