
/**
 * @version $Revision: 1.3 $ $Author: mgovinda $ $Date: 2001/05/08 20:05:59 $ (GMT) 
 * @author Madhusudhan Govindaraju [mailto:mgovinda@extreme.indiana.edu]
 */

/**
 * Implementation of a simple singleton pattern
 * for the connection and creation pseudo components.
 */
package xcat.framework.ccacore;

import xcat.framework.creation.CreationService;
import xcat.framework.creation.CreationServiceImpl;
import xcat.framework.connection.ConnectionService;
import xcat.framework.connection.ConnectionServiceImpl;
import soaprmi.util.Logger;
import soaprmi.util.Level;
  
public final class FrameworkServicesSingletonFactory {
  private static CreationService creationService = null;
  private static ConnectionService connectionService = null;
  private static boolean connectionsDone = false;
  private static Logger logger = Logger.getLogger();
  
  public synchronized static CreationService getCreationService() {
    logger.log(Level.FINER, "called");
    if (creationService == null) {
      creationService = new CreationServiceImpl();
    }
    return creationService;
  }

  public synchronized static ConnectionService getConnectionService() {
    logger.log(Level.FINER, "called");
    if (connectionService == null) {
      connectionService = new ConnectionServiceImpl();
    }
    return connectionService;
  }
}




