/**
 * @version $Revision: 1.3 $ $Author: mgovinda $ $Date: 2001/05/08 20:06:00 $ (GMT) 
 * @author Madhusudhan Govindaraju [mailto:mgovinda@extreme.indiana.edu]
 **/

package xcat.framework.ccacore;

/**
 * A user uses an object that implements
 * the PortInfo interface to define the
 * name and type of the object that she
 * is registering using the 
 * addProvidesPort(...) and
 * registerUsesPort(...) methods.
 */

public interface PortInfo {
  /** 
   * Returns the type of the Port referred to by this 
   * PortInfo: corresponds to the 
   * class or interface name for this Port.
   */
  public String getType();
  
  /** 
   * Returns the instance name for this Port.  
   * This name must be unique within the scope of a CCA component.
   */
  public String getName();
  
  /** 
   * Returns the string value for this property, 
   * or null if it is nonexistent. 
   */
  public String getProperty(String name);

  public String toString();
}


