/**
 * @version $Revision: 1.3 $ $Author: mgovinda $ $Date: 2001/05/08 20:06:00 $ (GMT) 
 * @author Madhusudhan Govindaraju [mailto:mgovinda@extreme.indiana.edu]
 **/

package xcat.framework.ccacore;

/**
 * PortRecord is used to store information
 * about the ports that the user registers
 * using addProvidesPort() and
 * registerUsesPort(). Once these ports
 * are registered, they can be retrieved
 * using the getPort() method.
 */
class PortRecord {
  private Port port;
  private PortInfo portInfo;
  
  public PortRecord(Port port_, PortInfo portInfo_) {
    port = port_;
    portInfo = portInfo_;
  }

  public PortRecord() {
    portInfo = new PortInfoImpl(" ", " ");
    port = null;
  }

  public Port getPort() {
    return port;
  }

  public PortInfo getPortInfo() {
    return portInfo;
  }
}

