/**
 * @version $Revision: 1.1 $ $Author: mgovinda $ $Date: 2001/05/08 20:11:57 $ (GMT) 
 * @author Madhusudhan Govindaraju [mailto:mgovinda@extreme.indiana.edu]
 **/

package xcat.framework.ccacore;

/**
 * The method assignProvidesPortImpl(...) needs to be invoked on the
 * provides port dyamic proxy  (ProvidesDynamicSkelImpl) so that 
 * the provides port that the users gives in addProvidesPort(...) 
 * can be stored in the dynamic proxy. This method cannot be 
 * made part of the ProvidesPort interface, as in that case 
 * the component developers will also have to implement this
 * method (in their implementation of the provides port). 
 */
public interface ProvidesPortImplInterface extends ProvidesPort {
  public void assignProvidesPortImpl(ProvidesPort thePort);
}
