
/**
 * @version $Revision: 1.3 $ $Author: mgovinda $ $Date: 2001/05/08 23:43:06 $ (GMT) 
 * @author Madhusudhan Govindaraju [mailto:mgovinda@extreme.indiana.edu]
 **/

package xcat.framework.ccacore;

import xcat.framework.exceptions.XCATException;

/**
 * This interface is specific to our
 * implementation of the framework. This
 * interface is used by the ServiceImpl.
 * Note that the API is exactly the same as
 * ComponentIDConnection except the exception that
 * is thrown. Services is a local object and cannot
 * throw RemoteExceptions
 */
public interface ServicesConnection  {
  public void xcatConnect(String usesPortName, ProvidesPort providesPort) 
    throws XCATException;
  public void xcatDisconnect(String usesPortName, ProvidesPort providesPort) 
    throws XCATException;
  public ProvidesPort xcatGetProvidesPort(String providesPortName) 
    throws XCATException;
  public void xcatExportAs(PortInfo newPortInfo, ProvidesPort providesPort) 
    throws XCATException;
  public void xcatProvideTo(String usesPortName, ProvidesPort providesPort) 
    throws XCATException;
  public String xcatGetPortTypeForPortName(String portName) 
    throws XCATException;
}
