/**
 * @version $Revision: 1.4 $ $Author: mgovinda $ $Date: 2001/05/08 20:06:01 $ (GMT) 
 * @author Madhusudhan Govindaraju [mailto:mgovinda@extreme.indiana.edu]
 **/
  
package xcat.framework.ccacore;

import soaprmi.Remote;
import soaprmi.util.Logger;
import soaprmi.util.Level;
import java.util.Vector;

/**
 *   Every usesPort instantiated by the framework
 *   needs to have the functionality to add and remove
 *   listeners. So, all these methods have been in put 
 *  the base class.
 */
public class UsesPortImpl implements  UsesPort {
  private boolean allVoids;
  private int refCount;
  protected Vector portList;
  private static Logger logger = Logger.getLogger();
  
  public UsesPortImpl(boolean allVoids_) {
    logger.finest("constructor called indicating all methods have void return type");
    allVoids = allVoids_;
    refCount = 0;
    portList = new Vector();
  }

  public UsesPortImpl() {
    this(false);
  }
  /**
   *
   */
  public void addListener(ProvidesPort providesPort) {
    logger.finest("adding " + providesPort);
    portList.addElement((Remote)providesPort);
  }
  
  public void removeListener(ProvidesPort providesPort) {
    // FIXME need to throw an exception if the port
    // doesn't exist and a remove call is called on it.
    logger.finest("removing " + providesPort);
    portList.removeElement(providesPort);
  }

  public Boolean hasAllVoidMethods() {
    return new Boolean(allVoids);
  }

  public Boolean isConnected() {
    boolean boolValue = (portList.size() > 0);
    return new Boolean(boolValue);
  }

  public void incrRefCount () {
    refCount++;
  }

  public void decrRefCount () {
    refCount--;
  }

  public Integer getRefCount () {
    return new Integer(refCount);
  }
}
