package xcat.framework.creation;

import xcat.framework.ccacore.ComponentID;
import xcat.framework.exceptions.XCATException;
import xcat.framework.util.EnvObj;
import xcat.framework.ccacore.Port;

/**
 * This interface is used by the user
 * to instantiate components using various
 * protocols like gram, rsh, ssh, exec and fork.
 *
 * @version $Revision: 1.5 $  $Author: mgovinda $ $Date: 2001/05/08 23:43:08 $ (GMT) 
 * @author Madhusudhan Govindaraju [mailto:mgovinda@extreme.indiana.edu]

 */

public interface CreationService extends Port {

  public ComponentID createInstance(EnvObj env)  throws XCATException;
  public void deleteInstance(ComponentID id) throws XCATException;
}
