
/**
 * @version $Revision: 1.1 $ $Author: mgovinda $ $Date: 2001/05/08 23:43:08 $ (GMT) 
 **/

package xcat.framework.exceptions;

public class XCATException extends Exception {
  public Throwable detail;
  private int row = -1;
  private int column = -1;

  
  public XCATException() {
    super();
  }
  
  public XCATException(String exceptionMessage) {
    super(exceptionMessage);
  }

  public XCATException(String exceptionMessage, Throwable ex) {
    super(exceptionMessage);
    detail = ex;
  }

  public Throwable getDetail() { return detail; }

  public String getMessage() {
    if(detail == null)
      return super.getMessage();
    else
      return super.getMessage() + "; nested exception is: \n\t" 
        + detail.toString();
      
  }

  public void printStackTrace(java.io.PrintStream ps) {
    if (detail == null) {
        super.printStackTrace(ps);
    } else {
        synchronized(ps) {
          //ps.println(this);
          ps.println(super.getMessage() + "; nested exception is:");
          detail.printStackTrace(ps);
        }
    }
  }

  public void printStackTrace() {
    printStackTrace(System.err);
  }

  public void printStackTrace(java.io.PrintWriter pw){
    if (detail == null) {
        super.printStackTrace(pw);
    } else {
      synchronized(pw) {
        //pw.println(this);
        pw.println(super.getMessage() + "; nested exception is:");
        detail.printStackTrace(pw);
      }
    }
  }
  
}
