// -*- Mode: Java -*-

package xcat.framework.util;

import soaprmi.util.Logger;
import soaprmi.util.Level;
import java.io.*;

/*
 * Utility for forking off processes (in the background); ASYNCHRONOUS!!!
 */

public class Fork {

  private static Logger logger = Logger.getLogger();

  String fd;
  Process pr;
  String cmd;

  static {
    logger.finest("Forking");
  }

  public Fork() {
    super();
    fd = System.getProperty("file.separator");
  }

  
  class ForkProcess implements Runnable {
    String fullcmd;
    ForkProcess(String c, String args) {
      cmd = c;
      fullcmd = cmd + " " + args;
    }
    public void run() {
      logger.finest("exec: "+fullcmd);
      try {
	pr = Runtime.getRuntime().exec(fullcmd);
      } catch (Exception e1) {
	pr = null;
	logger.severe("Exception: ", e1);
      }
    }
  }

  class ForkProcessIO extends Thread {
    BufferedReader br;
    String s,prefix;
    ForkProcessIO(String px, InputStream is) {
      prefix = px;
      try {
	br = new BufferedReader(new InputStreamReader(is),256);
      } catch (Exception e0) {
	logger.severe("Exception:=", e0);
	br = null;
      }
      s = null;
    }
    public void run() {
      if (br==null) return;
      for (;;) {
	try {
	  s = br.readLine();
	  if (s==null) break;
	  logger.severe(prefix+": "+s);
	} catch (Exception e) {
	  logger.severe(prefix+" Exception: ", e);
	  break;
	}
      }
    }
  }

  public void forkProcess(String cmd) {
    forkProcess(">>>>>>", "", cmd, "");
  }
  
  public void forkProcess(String prefix, String precmd, String cmd, String args) {
    // determine the "real" command to execute
    if ((cmd==null)||(cmd.trim().length()<1)) {
      cmd = precmd;
    } else {
      cmd = precmd + " " + cmd;
    }
    cmd = cmd.trim();
    // parse for positional parameters
    int i = cmd.indexOf("%s");
    if (i>=0) {
      cmd = cmd.substring(0,i) + args + cmd.substring(i+2);
      args = "";
    }
    logger.finest("ForkProcess: cmd="+cmd+", args="+args);
    // create the process in a (blocking) thread
    (new ForkProcess(cmd,args)).run();
    if (pr==null) {
      logger.severe("ERROR:  Unable to execute "+cmd+" !");
    } else {
      // print the output in a separate (non-blocking) thread
      (new ForkProcessIO(prefix,pr.getInputStream())).start();
      // print the error in a separate (non-blocking) thread
      (new ForkProcessIO(prefix+" (FORK)",pr.getErrorStream())).start();
    }
  }
}
