
//-------------------------74-columns-wide-------------------------------|

/**
 * @version $Revision: 1.2 $ $Author: mgovinda $ $Date: 2001/05/08 23:43:09 $ (GMT) 
 **/

package xcat.framework.util;

import xcat.framework.ccacore.Services;
import xcat.framework.ccacore.ComponentID;
import xcat.framework.ccacore.Component;
import xcat.framework.ccacore.ServicesImpl;
import xcat.framework.util.SoapConnectionClient;
import xcat.framework.util.XCATClassLoader;
import xcat.framework.exceptions.XCATException;
import soaprmi.RemoteException;
import soaprmi.util.Logger;
import soaprmi.util.Level;
import java.io.PrintStream;
import java.io.FileOutputStream;
import java.io.FileNotFoundException;
import java.lang.reflect.Constructor;
import java.net.URL;
import java.net.MalformedURLException;
import java.lang.reflect.InvocationTargetException;

public class SoapComponentInstantiator {
  
  private int creationServicePORT = -1024;
  private String creationServiceHost = null;
  private String nameOfComponent = "DEFAULT-NAME";
  private String fqnOfComponent = "DEFAULT-FQN";
  private static String localHost = "DEFAULT";
  private boolean stopWaiting = false;
  public static final String RELEASE = "$Revision: 1.2 $ by $Author: mgovinda $ on $Date: 2001/05/08 23:43:09 $ (GMT)";
  private static Logger logger = Logger.getLogger();

  public static void main(String args[]) {
    System.out.println(RELEASE);
    try {
      SoapComponentInstantiator soapComponentInstantiator = 
	new SoapComponentInstantiator();
      soapComponentInstantiator.initialize(args);
    } catch (FileNotFoundException fnfe) {
      logger.severe("Unable to open printer.out file, exiting", fnfe);
      System.exit(-1);
    }
  }

  public SoapComponentInstantiator() {
  }
  
  private void parseCommandLineArgs(String args[]) {
    logger.finest(args.length + " CommandLineArgs found ");
    creationServiceHost = args[0];
    creationServicePORT = Integer.parseInt(args[1]);
    nameOfComponent = args[2];
    fqnOfComponent = args[3];
    String blank = " ";
    logger.finer(creationServiceHost + blank + creationServicePORT);
  }
  
  
  public void initialize(String[] args) throws FileNotFoundException {

    parseCommandLineArgs(args);
    String outputFileName = nameOfComponent + ".out";
    logger.setSink(new PrintStream(new FileOutputStream(outputFileName, true)));
    Class componentClass = null;
    Services componentCore = null;
    Class[] type = new Class[1];
    Object[] param = new Object[1];
    //    type[0] = Class.forName(fqnOfComponent);
    param[0] = null;
    URL cburl = null;
    String codebase = "";
    try {
      cburl = new URL(codebase);
    }
    catch(Exception e) {
      cburl = null;
    }
    //    try {
    //        if(!componentClass.isAssignableFrom
    //  	 (XCATClassLoader.loadClass(cburl, fqnOfComponent)))
    //  	logger.severe("Unable to load a class from the following classpath: " + fqnOfComponent);
    //      }
    //      catch(Exception e) {
    //        e.printStackTrace();
    //        return;
    //      }
    Component component;
    try {
      componentClass = XCATClassLoader.loadClass(cburl, fqnOfComponent);
    } catch (MalformedURLException murle) {
      murle.printStackTrace();
      logger.severe("Unable to load class for  " + fqnOfComponent, murle);
      return;
    } catch (ClassNotFoundException cnfe) {
      cnfe.printStackTrace();
      logger.severe("Unable to find class for  " + fqnOfComponent, cnfe);
      return;
    }
    // get the empty constructor for the component
    Constructor componentConstructor;
    try {
      componentConstructor = componentClass.getConstructor(null);
    } catch (NoSuchMethodException nsme) {
      nsme.printStackTrace();
      logger.severe("Unable to get empty constructor of " + fqnOfComponent, nsme);
      return;
    }
    // create an instance of the component
    try {
      component = (Component)componentConstructor.newInstance(null);
    } catch (InvocationTargetException ite) {
      ite.printStackTrace();
      logger.severe("Unable to get empty constructor of " + fqnOfComponent, ite);
      return;
    } catch (IllegalAccessException iae) {
      iae.printStackTrace();
      logger.severe("Can't instantiate  " + fqnOfComponent, iae);
      return;
    } catch (InstantiationException iex) {
      iex.printStackTrace();
      logger.severe("Can't instantiate  " + fqnOfComponent, iex);
      return;
    }
    
    try {
      componentCore = new ServicesImpl();
      component.setServices(componentCore);
    } catch (XCATException xcate) {
      logger.severe("unable to set  core ", xcate);
      xcate.printStackTrace();
      return;
    } catch (Exception e) {
      logger.severe("unable to set  core ", e);
      return;
    }
   
    ComponentID componentID = null;
    try {
      componentID = componentCore.getComponentID();
    } catch (XCATException xcate) {
      logger.severe("unable to invoke getComponentID() ", xcate);
      xcate.printStackTrace();
      return;
    }
    
    if (componentID == null) {
      logger.severe("componentID is null!");
      throw new NullPointerException("componentID is null !!\n");
    }
    SoapConnectionClient soapConnectionClient = new SoapConnectionClient();
    try {
      soapConnectionClient.sendMyComponentID(creationServiceHost, creationServicePORT, componentID);
    } catch (RemoteException re) {
      logger.severe("unable to set  core ", re);
      re.printStackTrace();
      return;
    } 
  }
}

