//-------------------------74-columns-wide-------------------------------|
package xcat.framework.util;

import soaprmi.Remote;
import soaprmi.RemoteException;
import xcat.framework.ccacore.ComponentID;

/**
 * @version $Revision: 1.3 $  $Author: mgovinda $ $Date: 2001/05/08 20:07:06 $ (GMT) 
 * @author Madhusudhan Govindaraju [mailto:mgovinda@extreme.indiana.edu]
 */

/**
 * SoapConnectionServerImpl receives a componentID from 
 * SoapConnectionClient. This call is made remotely.
 * Hence SoapConnectionServerImpl needs to implement
 * a remote interface.
 */
public interface SoapConnectionServer extends Remote {
  /**
   * @param instantiatedComponentID: componentID of the 
   * instantiated component.
   */
  public void sendComponentID(ComponentID instantiatedID) 
    throws RemoteException;
}



